cppcms::widgets::select_base Class Referenceabstract

This is the base class for "select" like widgets which include dropdown lists and radio button sets. More...

`#include <cppcms/form.h>`

Inheritance diagram for cppcms::widgets::select_base:

## Classes

struct | element

## Public Member Functions

void | add (std::string const &string)
void | add (std::string const &string, std::string const &id)
void | add (locale::message const &msg)
void | add (locale::message const &msg, std::string const &id)
int | selected ()
std::string | selected_id ()
void | selected (int no)
void | selected_id (std::string id)
void | non_empty ()
virtual void | render_input (form_context &context)=0
virtual bool | validate ()
virtual void | load (http::context &context)
virtual void | clear ()
Public Member Functions inherited from cppcms::widgets::base_widget
| base_widget ()
bool | set ()
bool | valid ()
std::string | id ()
std::string | name ()
locale::message | message ()
bool | has_message ()
locale::message | error_message ()
bool | has_error_message ()
locale::message | help ()
bool | has_help ()
bool | disabled ()
void | disabled (bool)
std::string | attributes_string ()
void | set (bool)
void | valid (bool)
void | id (std::string)
void | name (std::string)
void | message (std::string)
void | message (locale::message const &)
void | error_message (std::string)
void | error_message (locale::message const &)
void | help (std::string)
void | help (locale::message const &msg)
void | attributes_string (std::string v)
virtual void | render (form_context &context)
virtual void | render_attributes (form_context &context)
virtual void | parent (base_form *subform)
virtual form * | parent ()
void | pre_load (http::context &)

## Protected Attributes

std::vector< element > | elements_

## Additional Inherited Members

Public Types inherited from cppcms::form_flags
enum | html_type { as_html = 0, as_xhtml = 1 }
enum | html_list_type { as_p = 0, as_table = 1, as_ul = 2, as_dl = 3, as_space = 4 }
enum | widget_part_type { first_part = 0, second_part = 1 }
Protected Member Functions inherited from cppcms::widgets::base_widget
void | auto_generate (form_context *context=0)

## Detailed Description

This is the base class for "select" like widgets which include dropdown lists and radio button sets.

## Member Function Documentation

void cppcms::widgets::select_base::add | ( | std::string const & | string | ) |

Add a new entry to the selection list.

void cppcms::widgets::select_base::add | ( | std::string const & | string,
|  | std::string const & | id
| ) |  |

Add to the selection list a new entry with the unique identification string id.

void cppcms::widgets::select_base::add | ( | locale::message const & | msg | ) |

Add a new localized entry to the selection list.

void cppcms::widgets::select_base::add | ( | locale::message const & | msg,
|  | std::string const & | id
| ) |  |

Add to the selection list a new localized entry with the unique identification string id.

virtual void cppcms::widgets::select_base::clear | ( |  | ) |

virtual

Clear the form. It also calls set(false).

Reimplemented from cppcms::widgets::base_widget.

virtual void cppcms::widgets::select_base::load | ( | http::context & | context | ) |

virtual

Load the form information from the provided http::context context. A user can call this function to load all information from the raw POST/GET data into the internal widget representation.

Implements cppcms::base_form.

void cppcms::widgets::select_base::non_empty | ( |  | ) |

Require that one item in the list should be selected (for the validation).

virtual void cppcms::widgets::select_base::render_input | ( | form_context & | context | ) |

pure virtual

This is a virtual member function that should be implemented by each widget. It executes the actual rendering of the HTML form.

Implements cppcms::widgets::base_widget.

Implemented in cppcms::widgets::radio, and cppcms::widgets::select.

int cppcms::widgets::select_base::selected | ( |  | ) |

Return the number of the selected entry in the list. Entries are numbered starting from 0. -1 indicates that nothing was selected.

void cppcms::widgets::select_base::selected | ( | int | no | ) |

Select the entry numbered no.

std::string cppcms::widgets::select_base::selected_id | ( |  | ) |

Return the identification string of the selected entry in the list. An empty string indicates that nothing was selected.

void cppcms::widgets::select_base::selected_id | ( | std::string | id | ) |

Select the entry with the identification string id.

virtual bool cppcms::widgets::select_base::validate | ( |  | ) |

virtual

Validate the form. If not overridden, it sets the widget to valid.

Reimplemented from cppcms::widgets::base_widget.

The documentation for this class was generated from the following file:

- cppcms/form.h